;31 baud PSK for 56002evm, g3plx
; serialbaudrate =19K2, changes to make use of port B0 as PTT line
; Mods at line nr:12, 191, 192, 193, 287 and  289 (PA0IHD 05-1997)
        page 132       
        include 'ioequ.asm'
        include 'codequ.asm'
	

ctlwd0          equ     nopreamp+highpass+samprate8+stereo+data16
ctlwd1          equ     immed3state+xtal2select+bits64+codecmaster
;output level reduced
outputset       equ     phoneson+lineouton+(leftattn*10)+(rightattn*10)
inputset        equ     mikeselect+(15*monitorattn)+(leftgain*1)+(rightgain*0)

baud    equ     19200       ;SCI baudrate to PC
decsize equ     32         ;size of decimation filter
filsize equ     64         ;receive filter 128mS long at 500Hz
sample  equ     8000.00    ;system sample rate
sintab  equ     $100       ;address of sine table in ROM

        org     X:0     ;codec receive timeslots
rslot0  dc      0       ;left audio from codec
rslot1  dc      0       ;right audio from codec
rslot2  dc      0       ;output level settings: bit 15 is busy flag
rslot3  dc      0       ;input level settings: bit 21 is overrange flag

ctlset  dc      ctlwd0  ;initialisation values for codec control mode
        dc      ctlwd1
        dc      0
        dc      0

        org     Y:0     ;codec transmit timeslots
tslot0  dc      0       ;left audio
tslot1  dc      0       ;right audio
tslot2  dc      0       ;output level settings
tslot3  dc      0       ;input level settings: bit 21 is overrange enable

dtaset  dc      0           ;initialisation values for codec data mode
        dc      0
        dc      outputset
        dc      inputset
lastY   =       *

        org     L:lastY  ;oscillator objects
rxosc   ds      2        ;X:(0)=freq, Y:(0)=phase, X:(1)=cos, Y:(1)=sin
txosc   ds      2        ;X:(0)=freq, Y:(0)=phase, X:(1)=cos, Y:(1)=sin
hposc   ds      2
rxIQ    ds      1        ;filtered receive I and Q for headphone output
lastL   =       *

        org     X:rxosc     ;initial values for oscillator frequencies
rxfreq  dc      1000/sample*2     ;rx osc freq   (user can change it)
        org     X:txosc
txfreq  dc      1000/sample*2     ;tx osc freq   (user can change it)
        org     X:hposc
hpfreq  dc      1000/sample*2      ;headphone freq (stays at 1 kHz)

        org     X:lastL
timeslot dc      0                ;counts 0,1,2,3 at 32kHz
nexttx   dc      0                ;0, +1, or -1 for next tx bit
lasttx   dc      0                ;0, +1, or -1 for previous tx bit
txenv    dc      0                ;transmit envelope value
uiptr    dc      0                ;points to frame bytes from user
txdata   dc      0                ;bit0:toggle, bit1:txon
uindata  dc      0                ;user input data 8-bit to 24-bit shift-in

lastX   =       *

         org    Y:lastL
atncof   dc     -8.69245892963590E-0002   ;power series coeffs for arctan
         dc      3.36924589284536E-0001
pattern  dc     $000000          ;octant 0    bit23:      1=subtract 0=add
         dc     $A00000          ;       1    bits 22,21: quadrant offset
         dc     $800000          ;       7
         dc     $600000          ;       6
         dc     $C00000          ;       3
         dc     $200000          ;       2
         dc     $400000          ;       4
         dc     $E00000          ;       5

;jump table for user input bytes in a frame
ujtab   dc      settxd         ;user sending tx data
        dc      userin         ;user sending rx freq hi
        dc      userin         ;user sending rx freq mi
        dc      rxfset         ;user sending rx freq lo
        dc      txfset         ;user locking tx freq to rx freq
        dc      nothin         ;shouldn't be any more from user
        dc      nothin
        dc      nothin
        dc      nothin
        dc      nothin
        dc      nothin
        dc      nothin
        dc      nothin
        dc      nothin
        dc      nothin
        dc      nothin
lastY   =       *

      if @cvi(lastY)>@cvi(lastX)
        org    L:lastY
      else
        org    L:lastX
      endif

monfil   dsm    16               ;interpolation filter for headphone output

decfil   dsm    decsize          ;decimation I/Q filters
lastL    =      *

         org    X:lastL
deccofs  equ *          ;triangular decimation filter (96db down at +/-500Hz)
count    set     0
total    =       @cvf(decsize)*@cvf(decsize)/2
         dup     decsize
       if count<16
         dc      @cvf(2*count+1)/total
       else
         dc      @cvf(2*(decsize-count)-1)/total
       endif
count    set     count+1
       endm
lastX    =      *

         org    L:lastX
filter   dsm    filsize          ;main receive I/Q filters
lastL    =      *
         org    X:lastL
coeffs   equ    *
PI       equ    3.14159265358979323846

s0       equ    0.5            ;DFT factors for main filter
s1       equ    1.15           ;>=64dB at >=31.25 Hz
s2       equ    0.7931
s3       equ    0.1567
s4       equ    0.00049
s5       equ    0.0005

time     =     -0.5*@cvf(filsize)+0.5
count    set    0
	 dup    filsize
angle    =      2*PI*time/@cvf(filsize)
coeff    =      s0+s1*@cos(angle)+s2*@cos(2.0*angle)+s3*@cos(3.0*angle)+s4*@cos(4.0*angle)+s5*@cos(5.0*angle)
time     =      time+1.0
	 dc     2*coeff/filsize
count    set    count+1
	 endm

;P: code for bottom $40 loaded in X: (under the ROM)
          org    P:$000C,X:$10C
          jsr    <ssirx               ;SSI rcv data default handler
          nop
          jsr    <ssirx               ;ssi rcv data error handler
          nop

          org     P:$0020,X:$120      ;(look, no registers!)
ssirx     bchg    #0,X:timeslot       ;toggle bit0
          jcs    <oddslot             ;skip if it was 1
evenslot  btst    #1,X:timeslot       ;test bit1
          jcs    <slot2               ;skip if it was 1
slot0     movep   X:M_RX,X:rslot0     ;get left input from codec
          movep   Y:tslot2,X:M_TX     ;put output setting to codec
          rti
oddslot   bchg    #1,X:timeslot       ;toggle bit1
          jcs    <slot3               ;skip if it was 1
slot1     movep   X:M_RX,X:rslot1     ;get right input from codec
          movep   Y:tslot3,X:M_TX     ;put input settings to codec
          rti
slot2     movep   X:M_RX,X:rslot2     ;get output settings from codec
          movep   Y:tslot0,X:M_TX     ;put left audio out to codec
          rti
slot3     movep   X:M_RX,X:rslot3     ;get input settings from codec
          movep   Y:tslot1,X:M_TX     ;put right audio out to codec
          rti

;mustn't load P: below $40 or the bootstrap will overwrite itself
        org     P:$40
start   ori     #3,MR           ;disable interrupts
        bclr    #2,OMR          ;disable ROMs
        move    #$100,R1        ;point to X: where P:$0 code is loaded
        move    #$00,R2         ;point to P:destination
        do      #$40,_emov
         move   X:(R1)+,A1
         move   A1,P:(R2)+
_emov   bset    #2,OMR          ;turn ROMs on now X:load code is done
        clr     A
        movep   #$1C0009,X:M_PCTL ;40 Mhz, disable clock output
        movep   A1,X:M_BCR        ;no waits
	movep   #$4303,X:M_CRA    ;40MHz/16 = 2.5MHz SCLK, WL=16 bits, 4W/F
        movep   #$BB30,X:M_CRB    ;rie,re,te, tie not needed
        movep   #$0000,X:M_PBC    ;-NEW- Port B, PA0IHD 18/05/1997
        movep   #$60FF,X:M_PBDDR  ;mod to use B0
        movep   #$0000,X:M_PBD    ;Last line of mod.....
	movep   #$1C,X:M_PCDDR    ;setup pc4, pc3 and pc2 as outputs
	movep   #$01E3,X:M_PCC    ;Turn on ssi,sci
        movep   #$0302,X:M_SCR    ;set SCR async, 8-bit
        movep   #(625000/baud-1),X:M_SCCR     ;set baudrate, internal clocks
	movep   A1,X:M_PCD        ;codec control mode, PTT off, hit reset
	do      #500,_endel       ;50mS delay
	rep     #2000             ; (100 us delay)
        nop
_endel  bset    #4,X:M_PCD        ;reset off
        movep   #$2000,X:M_IPR    ;IPR=2 for ssi
        move    #ctlset,R1        ;source=codec control-settings
        move    #tslot0,R2        ;destn=transmit slots
        do      #4,_eset
         move   X:(R1)+,X0        ;move them
         move   X0,Y:(R2)+
_eset   andi    #$FC,MR           ;SSI interrupt will now fire
waitfr  wait
        jclr    #2,X:M_SR,waitfr  ;wait for rx frame sync
        move    A1,X:timeslot     ;synchronise the timeslot pointer
wait0   wait
        jset    #18,X:rslot0,wait0   ;wait for CLB=0
        bset    #18,Y:tslot0         ;set CLB=1
wait1   wait
        jclr    #18,X:rslot0,wait1   ;wait for CLB=1
        move   #dtaset,R1            ;source=codec data-settings
        move   #tslot0,R2            ;destn=transmit slots
        do      #4,_eset
         move   Y:(R1)+,A            ;move them
         move   A1,Y:(R2)+
_eset   movep   #$BB00,X:M_CRB       ;set SCLK,FS to input
	bset    #2,X:M_PCD           ;switch to data mode
_cal    wait
        jclr    #15,X:rslot2,_cal    ;wait for calibration to finish
        bset    #0,X:rslot0          ;mark junk left audio
;done codec setup
; following registers are used globally
        move    #$FF,M0              ;size of sine table
        move    #filter,R1           ;main receive filter ptr
        move    #filsize-1,M1        ;size of main receive filter
        move    #0,R2                ;just counts 0..255 at 8 kHz
        move    #$FF,M2              ;counter modulo  (32mS cycle)
        move    #decfil,R3           ;decimation filter ptr
        move    #decsize-1,M3        ;decimation filter modulo
        move    #$FFFF,M4            ;linear addressing used various
        move    #monfil,R5           ;headphone monitor interpolation filter
        move    #15,M5               ;headphone interpolation filter modulo
;                        R6,M6,R7,M7 not used
;this is the main loop which is run at 32kHz
main    wait
        jset    #0,X:rslot0,main         ;loop until new left audio input
;8 kHz
        move    #rxosc,R4                ;point to receive oscillator
        jsr     oscill                   ;do it
        move    X:rslot0,X0   A,Y1       ;get left input and rx osc cosine
        mpyr    X0,Y1,A       B,Y1       ;mix with input, get rx osc sine
        mpyr    X0,Y1,B       (R2)+      ;mix with input: count round 32mS
        move    AB,L:(R3)+               ;store I/Q in decimation filter
        bset    #0,X:rslot0              ;mark audio input as "old"

        move    R2,B                     ;test for 31.25Hz processes
        tst     B
        jne    <txwave

;here at 31.25Hz to fetch next tx bit
        move    X:nexttx,A
        move    A,X:lasttx               ;move new tx bit amplitude to old
        jset    #1,X:txdata,txbit1
        clr     A                        ;tx off if txdata bit1=0
        jmp    <txbit2
txbit1  tst     A      #$7FFFFF,X0
        teq     X0,A                     ;set amplitude = +1.0 if tx was off
        jset    #0,X:txdata,txbit2
        neg     A                        ;toggle amplitude if txdata bit0=0
txbit2  move    A1,X:nexttx              ;put out new amplitude
        move    B1,X:txdata              ;clear txdata for txoff if no next

;now do transmit waveform at 8 kHz
txwave  move    R2,B                     ;get counter
        asr     B           #>$140,X0    ;divide count by 2
        add     X0,B                     ;add into middle-half of sinetable
        move    B1,R0                    ;move to address register
        move    #$7FFFFF,Y0              ;set Y0=1.0: pipeline
        move    Y:(R0),A                 ;get sine value from ROM
        asr     A           #0.5,X0      ;divide by 2
        add     X0,A                     ;0.5*(1+sin(count/2))=r/cos for last bit
        move    A1,A
        neg     A         A,X0           ;0.5*(-1-sin((count/2): save last
        add     Y0,A      X:lasttx,X1    ;0.5*(1-sin(count/2))
        move    A,Y0                     ;Y0=raised-cosine for next bit
        mpy     X0,X1,A   X:nexttx,Y1
        macr    Y0,Y1,A                  ;form composite envelope amplitude
        move    A,X:txenv                ;save result (-1.0 to +1.0)
        jeq    <pttoff
ptton   bset    #0,X:M_PBD               ;Bit 0, port B (was #3,X:M_PCD)
        jmp    <ptt
pttoff  bclr    #0,X:M_PBD               ;Bit 0, port B (was #3,X:M_PCD)
ptt     move    #txfreq,R4               ;point to tx oscillator
        jsr     oscill                   ;do it
        move    B,X0                     ;get tx sine wave
        move    X:txenv,X1
        mpy     X0,X1,A                  ;form tx waveform
        move    A,Y:tslot0               ;tx waveform out

;here do headphone output
        move    #hpfreq,R4               ;point to headphone oscillator
        jsr     oscill                   ;do it (R4 points to cos/sin)
        move    L:rxIQ,A                 ;get I and Q from rx filter
        move    A10,L:(R5)+              ;put into interpolation filter
        clr     A      L:(R5)+,X         ;clear Isum: get first I/Q
        clr     B      #1.00/16,Y0       ;clear Qsum: get constant coeff
        do      #15,_efil                ;calculate interpolation filter o/p
         mac    X1,Y0,A   X:(R5),X1
         mac    X0,Y0,B   Y:(R5)+,X0
_efil   macr    X1,Y0,A
        macr    X0,Y0,B   A,X1      ;interpolated I and Q now in A and B
        move    L:(R4),Y            ;get cos(hpfreq) and sin(hpfreq)
        mpy     X1,Y1,A   B,X0      ;multiply rxI, get rxQ
        macr    X0,Y0,A             ;mpy rxQ and add
        move    A1,Y:tslot1         ;output rx audio to right headphone

        move    R2,B                ;test for 500Hz processes
        move    #>15,X0
        and     X0,B      #>8,X0       ;mask to 0..15
        cmp     X0,B                   ;test for count=8
        jne     main                   ;skip if not((count mod 16)=8)

;here at 500Hz interleaved between 31.25Hz processes
;receive decimation filter output calculation
        clr     A        #deccofs,R4
        clr     B
        move    X:(R4)+,X0              ;get 1st coeff
        move    L:(R3)+,Y               ;get I/Q
        do      #decsize-1,rxf0
         mac    X0,Y1,A  X:(R3),Y1
         mac    X0,Y0,B  Y:(R3)+,Y0  X:(R4)+,X0
rxf0    macr    X0,Y1,A
        macr    X0,Y0,B     
        move    AB,L:(R1)+         ;decimation filter output into main filter

        clr     A        #coeffs,R4
        clr     B
        move    X:(R4)+,X0                       ;get 1st coeff
        move    L:(R1)+,Y                        ;get I/Q
        do      #filsize-1,rxf1                  ;do main filters
         mac    X0,Y1,A  X:(R1),Y1               ;do Istep
         mac    X0,Y0,B  Y:(R1)+,Y0 X:(R4)+,X0   ;do Qstep
rxf1    macr   X0,Y1,A                           ;do last macs
        macr   X0,Y0,B                           ;and round off
        move   AB,L:rxIQ                         ;save for headphone output

;now calculate the phase angle from the I and Q values
arctan  move    #pattern,R4                 ;R4 will point to octant
        tst     A           #4,N4
        jpl    <atan1
        abs     A           (R4)+N4         ;if I<0  then add 4 to R4
atan1   tst     B           #2,N4
        jpl    <atan2
        abs     B           (R4)+N4         ;if Q<0 then add 2
atan2   cmp     A,B         A,X0
        jmi    <atan3
        tfr     X0,B        B,X0            ;if Q>I then swap..
        move    (R4)+                       ;and add 1
atan3   move    R4,N4                       ;save octant pointer in N4 temp
        move    #atncof,R4                  ;point to coefficients
        andi    #$FE,ccr                    ;clear carry bit
        rep     #24
         div    X0,B                        ;divide to get tan
        move    B0,X1                       ;..into X1
        move    Y:(R4)+,X0                  ;get 2nd-order coefficient
        mpyr    X0,X1,A     Y:(R4),X0       ;k2*X1, fetch k1
        add     X0,A                        ;k2*X1+k1
        move    A,X0
        mpyr    X0,X1,A    N4,R4            ;(k2*X1+k1)*X1: get octant
        move    A1,X1
        move    Y:(R4),A                    ;get octant pattern/offset
        asl     A          #$FE,X0          ;shift msb to carry
        jcc    <atan4
        sub     X1,A                        ;if C set then subtract from
        jmp    <atan5
atan4   add     X1,A                        ;if C clr then add to
atan5

;feed phase value to user at 500Hz, with frame sync lsb at 31.25Hz
        move    R2,B                        ;get counter
        and     X0,A       #>$F0,X0         ;mask phase to 7 msb
        and     X0,B       #$01,X0          ;mask counter to 500Hz
        jne    <rxout                       ;jump if not zero
        or      X0,A                        ;if zero, set lsb for frame sync
        move    B,X:uiptr                   ;clear user input frame pointer
rxout   move    A1,X:M_STXH                 ;send to user

;process data from user
        jclr    #2,X:M_SSR,main             ;skip if no byte waiting
        move     #ujtab,N4                  ;point to base of jump table
        move     X:uiptr,R4                 ;get user input frame pointer
        nop                                 ;pipeline
        move     Y:(R4+N4),R0               ;get address from table
        move    (R4)+                       ;increment frame pointer
        jsr     (R0)                        ;process this byte
        move     R4,X:uiptr                 ;save frame pointer for next
        jmp     main

userin  move     X:uindata,A     ;get (maybe) previous input data
        rep      #8
         asl     A               ;shift it up one byte
        movep    X:M_SRXL,X0     ;get new byte
        or       X0,A            ;put it into lobyte
        move     A1,X:uindata    ;need it all later
        rts

rxfset  jsr      userin         ;shift last byte in
        move     A1,X:rxfreq    ;put all 3 bytes into rxfreq location
        rts

txfset  movep    X:M_SRXL,A1    ;get byte
        jclr     #0,A1,nothin   ;skip if lsb=0
        move     X:rxfreq,A1    ;if 1 then lock tx to rx
        move     A1,X:txfreq
nothin  rts                     ;here also if too many bytes in user frame

settxd  movep    X:M_SRXL,A     ;get byte
        move     A1,X:txdata    ;put out for next tx bit
        rts

;this subroutine, called at 8 kHz, runs the oscillator that R4 is pointing
;at and returns it's cos and sin values in A and B
oscill  move	X:(R4),A                  ;get frequency
        move    Y:(R4),X0                 ;get current phase
	add	X0,A	    #>$80,X1      ;add frequency to phase
	move	A1,Y:(R4)+                ;save new phase
	mpy     X0,X1,A     #>$FF,X0      ;shift right 16, remainder to A0
        and     X0,A        #$100,X0      ;mask A1 to 8 lsb
	or      X0,A        #$40,N0       ;form sine ROM table address
	move    A1,R0                     ;move ROM address to R0
	move    A0,Y0                     ;move remainder to Y0
	jclr    #23,Y0,round
	move    (R0)+                     ;round up if Y0>$7FFFFF
round	move    Y:(R0+N0),X0              ;X0=coarse cosine
	move    Y:(R0),X1                 ;X1=coarse sine
	mpyr    X1,Y0,A    #PI/256.0,Y1   ;A=sin*rem
       	tfr     X0,A       A,X1           ;fetch cos, move sin*rem
	macr   -X1,Y1,A                   ;A=cos-sin*rem*pi/256 (=fine cos)
	mpyr    X0,Y0,B    Y:(R0),X1      ;B=cos*rem, read sin again
	tfr     X1,B       B,X1           ;fetch sin, move cos*rem
	macr    X1,Y1,B    A,X:(R4)       ;B=sin+cos*rem*pi/256 (=fine sine)
        move    B,Y:(R4)                  ;save sine
        rts

        end     start
